#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <netdb.h>
#include <pthread.h>
#include <setjmp.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <netinet/ip_icmp.h>
#include <net/if.h>
#include <linux/sockios.h>
#include <unistd.h>

 
#ifdef HAVE_CONFIG_H
 #include <config.h>
#endif

#ifdef HAVE_X11_XLIB_H
 #include <X11/Xlib.h>
#endif

#ifdef HAVE_RPC_RPC_H
 #include <rpc/rpc.h>
 #include <rpc/xdr.h>
 #include <rpc/pmap_prot.h>
 #include <rpc/pmap_clnt.h>
 #include <rpcsvc/yp_prot.h>
 #include <rpcsvc/ypclnt.h>
#endif

#ifdef STDC_HEADERS
 #include <stdlib.h>
#endif



#define version "ech0 Security Scanner beta 0.8.6"
#define CFILE "ess.conf"

/* FUNCTIONS */
void main(int argc,char *argv[]);
void nfschk(char showmount[]);
void logger(char *string);
void rloginchk();
void namedchk();
int rshchk();
void portscan();
void ring();
void processport(char *protoc);
int gatechk();
char *uptolow(char *str);
int timeout(int woption,int timewait);
int getportbydaem(char *daemname,char *protoc);
char *port2daemon(int portnum);
char *confparser(char *option);
int check4bug(char *string,int daemon);
int connport(int cport,int option);
int httpchk(int cgiscan,char *cgidatafile);
int rpc_scan(char showmnt[]);
int telnetchk();
int smtpchk();
int ftpchk();
int fingerchk();
int pop2chk();
int pop3chk();
int imapchk();
int doport();
int recvpoll(int outputopt,int time2wait);
int recvbuff(int outputopt);
int checkX(char *ip);
int parse_space(char string[1024]);
int recvraw();
int pollgrab(int sockfd,fd_set fset,char *lakis,struct timeval tv);
void pollsend(int sockfd,fd_set writeset,char *lakis,struct timeval tv);
int get_local_ip(char *nInterface);
void oscheck(int tcpwinsize,int tcpfrag,int tcpttl,int tcptos);
void keeptcpstack(int tcpwinsize,int tcpttl,int tcptos,int tcpfrag);
void overANDout(int sig);

int sock;
int lag_sec;
int portmax;
int porti;
int ftpdport,telnetdport,smtpdport,fingerdport,httpdport,pop2dport,pop3dport,imapdport,rpcbindport,rloginport,rshport,xwinport,namedport;
int ftpscan,telnetscan,smtpscan,fingerscan,httpscan,pop2scan,pop3scan,imapscan,rpcscan,rloginscan,rshscan,xwinscan,namescan;
int wingatelog;
int portscanopt;
int conntimeout;
int doneportscan;
int timeoutno;
int firewallguess;
char str1[1024];
char host2scan[1024];
char *ip2scan;
char localip[255];
char localIPs[1024];
char *curruser;
char *rebuff;
char *servicefile;
char osfound[100];
FILE *logfile;
struct hostent *he;
pthread_mutex_t lock;
struct ifreq ifr;
 
struct portinfo
{ int port;
  char portname[1024]; } portdata[4096];
int udp_lag_sec;

struct parseline
{ char buff[255]; } parseline[255];

struct tcpdata
{ int winsize;
  int ttl;
  int tos;
  int frag; 
  int num; } tcpprint[10];
int majorityfrag;
char tcpstacks[200];

char *user2fing;
char *user2vrfy;
char *dir2chk;
char *ftpuser;
char *rshuser;

struct timeval tval;
fd_set readfs;
fd_set writefs;
